diff --git a/tensorflow/python/kernel_tests/reduce_benchmark_test.py b/tensorflow/python/kernel_tests/reduce_benchmark_test.py
index ef9c4c350fd..9f184802878 100644
--- a/tensorflow/python/kernel_tests/reduce_benchmark_test.py
+++ b/tensorflow/python/kernel_tests/reduce_benchmark_test.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 import time
 
 import numpy as np
-from six.moves import range  # pylint: disable=redefined-builtin
 
 from tensorflow.core.protobuf import config_pb2
 from tensorflow.python.client import session
diff --git a/tensorflow/python/kernel_tests/reduce_join_op_test.py b/tensorflow/python/kernel_tests/reduce_join_op_test.py
index 751e3e3648b..aa2937e4016 100644
--- a/tensorflow/python/kernel_tests/reduce_join_op_test.py
+++ b/tensorflow/python/kernel_tests/reduce_join_op_test.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 import itertools
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import dtypes
@@ -41,7 +40,7 @@ def _input_array(num_dims):
     An ndarray of shape [2] * num_dims.
   """
   formatter = "{:0%db}" % num_dims
-  strings = [formatter.format(i) for i in xrange(2**num_dims)]
+  strings = [formatter.format(i) for i in range(2**num_dims)]
   return np.array(strings, dtype="S%d" % num_dims).reshape([2] * num_dims)
 
 
@@ -58,10 +57,10 @@ def _joined_array(num_dims, reduce_dim):
   formatter = "{:0%db}" % (num_dims - 1)
   result = np.zeros(shape=[2] * (num_dims - 1), dtype="S%d" % (2 * num_dims))
   flat = result.ravel()
-  for i in xrange(2**(num_dims - 1)):
+  for i in range(2**(num_dims - 1)):
     dims = formatter.format(i)
     flat[i] = "".join([(dims[:reduce_dim] + "%d" + dims[reduce_dim:]) % j
-                       for j in xrange(2)])
+                       for j in range(2)])
   return result
 
 
@@ -78,7 +77,7 @@ class ReduceJoinTestHelperTest(UnicodeTestCase):
 
   def testInputArray(self):
     num_dims = 3
-    truth = ["{:03b}".format(i) for i in xrange(2**num_dims)]
+    truth = ["{:03b}".format(i) for i in range(2**num_dims)]
     output_array = _input_array(num_dims).reshape([-1])
     self.assertAllEqualUnicode(truth, output_array)
 
@@ -188,26 +187,26 @@ class ReduceJoinTest(UnicodeTestCase):
 
   def testRankFive(self):
     input_array = _input_array(num_dims=5)
-    truths = [_joined_array(num_dims=5, reduce_dim=i) for i in xrange(5)]
+    truths = [_joined_array(num_dims=5, reduce_dim=i) for i in range(5)]
     truth_shape = [2] * 4
-    for i in xrange(5):
+    for i in range(5):
       self._testReduceJoin(input_array, truths[i], truth_shape, axis=i)
 
   def testNegative(self):
     input_array = _input_array(num_dims=5)
-    truths = [_joined_array(num_dims=5, reduce_dim=i) for i in xrange(5)]
+    truths = [_joined_array(num_dims=5, reduce_dim=i) for i in range(5)]
     truth_shape = [2] * 4
-    for i in xrange(5):
+    for i in range(5):
       self._testReduceJoin(input_array, truths[i], truth_shape, axis=i - 5)
 
   def testSingletonDimension(self):
     input_arrays = [
         _input_array(num_dims=5).reshape([2] * i + [1] + [2] * (5 - i))
-        for i in xrange(6)
+        for i in range(6)
     ]
     truth = _input_array(num_dims=5)
     truth_shape = [2] * 5
-    for i in xrange(6):
+    for i in range(6):
       self._testReduceJoin(input_arrays[i], truth, truth_shape, axis=i)
 
   def testSeparator(self):
@@ -296,8 +295,8 @@ class ReduceJoinTest(UnicodeTestCase):
     num_dims = 3
     input_array = _input_array(num_dims=num_dims)
     # Also tests [].
-    for i in xrange(num_dims + 1):
-      for permutation in itertools.permutations(xrange(num_dims), i):
+    for i in range(num_dims + 1):
+      for permutation in itertools.permutations(range(num_dims), i):
         self._testMultipleReduceJoin(input_array, axis=permutation)
 
   @test_util.run_deprecated_v1
diff --git a/tensorflow/python/kernel_tests/relu_op_test.py b/tensorflow/python/kernel_tests/relu_op_test.py
index eed8bd7d258..b9f6161fb4a 100644
--- a/tensorflow/python/kernel_tests/relu_op_test.py
+++ b/tensorflow/python/kernel_tests/relu_op_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python import tf2
 from tensorflow.python.compat import compat
@@ -159,7 +158,7 @@ class ReluTest(test.TestCase):
 
     # Repeat the experiment for 100 times. All tensor shapes and its tensor
     # values are randomly generated for each run.
-    for _ in xrange(100):
+    for _ in range(100):
       d32, d16 = f()
       self.assertAllClose(d32, d16, atol=3e-4)
 
diff --git a/tensorflow/python/kernel_tests/reverse_sequence_op_test.py b/tensorflow/python/kernel_tests/reverse_sequence_op_test.py
index 05307c9834a..04c25e0a3ef 100644
--- a/tensorflow/python/kernel_tests/reverse_sequence_op_test.py
+++ b/tensorflow/python/kernel_tests/reverse_sequence_op_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import dtypes
@@ -183,7 +182,7 @@ class ReverseSequenceTest(test.TestCase):
       with self.assertRaisesOpError("batch_dim == seq_dim"):
         output.eval(feed_dict={
             inputs: np.random.rand(32, 2, 3),
-            seq_lengths: xrange(32)
+            seq_lengths: range(32)
         })
 
 
diff --git a/tensorflow/python/kernel_tests/rnn_test.py b/tensorflow/python/kernel_tests/rnn_test.py
index bdb01700582..4d04a8e823d 100644
--- a/tensorflow/python/kernel_tests/rnn_test.py
+++ b/tensorflow/python/kernel_tests/rnn_test.py
@@ -24,7 +24,6 @@ import timeit
 
 import numpy as np
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 from tensorflow.core.protobuf import config_pb2
 from tensorflow.python import keras
 from tensorflow.python.client import session
@@ -1199,7 +1198,7 @@ class BenchmarkRNN(test.Benchmark):
       rnn_long_sequence_benchmark(batch_size, seqlen, num_units,
                                   dynamic, swap_memory, 2)
     # Measure the performance.
-    for slen in xrange(100, 1100, 100):
+    for slen in range(100, 1100, 100):
       rnn_long_sequence_benchmark(batch_size, slen, num_units, dynamic,
                                   swap_memory, 3)
 
diff --git a/tensorflow/python/kernel_tests/signal/fft_ops_test.py b/tensorflow/python/kernel_tests/signal/fft_ops_test.py
index b5858e3ac08..f11a8d46bc9 100644
--- a/tensorflow/python/kernel_tests/signal/fft_ops_test.py
+++ b/tensorflow/python/kernel_tests/signal/fft_ops_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.protobuf import config_pb2
 from tensorflow.python.framework import dtypes
@@ -163,7 +162,7 @@ class FFTOpsTest(BaseFFTOpsTest):
     with spectral_ops_test_util.fft_kernel_label_map():
       for np_type in (np.complex64, np.complex128):
         for rank in VALID_FFT_RANKS:
-          for dims in xrange(rank, rank + 3):
+          for dims in range(rank, rank + 3):
             x = np.zeros((0,) * dims).astype(np_type)
             self.assertEqual(x.shape, self._tfFFT(x, rank).shape)
             self.assertEqual(x.shape, self._tfIFFT(x, rank).shape)
@@ -173,7 +172,7 @@ class FFTOpsTest(BaseFFTOpsTest):
     with spectral_ops_test_util.fft_kernel_label_map():
       for np_type, tol in ((np.complex64, 1e-4), (np.complex128, 1e-8)):
         for rank in VALID_FFT_RANKS:
-          for dims in xrange(rank, rank + 3):
+          for dims in range(rank, rank + 3):
             self._compare(
                 np.mod(np.arange(np.power(4, dims)), 10).reshape(
                     (4,) * dims).astype(np_type), rank, rtol=tol, atol=tol)
@@ -181,7 +180,7 @@ class FFTOpsTest(BaseFFTOpsTest):
   def testLargeBatch(self):
     if test.is_gpu_available(cuda_only=True):
       rank = 1
-      for dims in xrange(rank, rank + 3):
+      for dims in range(rank, rank + 3):
         for np_type, tol in ((np.complex64, 1e-4), (np.complex128, 1e-5)):
           self._compare(
               np.mod(np.arange(np.power(128, dims)), 10).reshape(
@@ -192,7 +191,7 @@ class FFTOpsTest(BaseFFTOpsTest):
   # def testLargeBatchMemoryFail(self):
   #   if test.is_gpu_available(cuda_only=True):
   #     rank = 1
-  #     for dims in xrange(rank, rank + 3):
+  #     for dims in range(rank, rank + 3):
   #       self._checkMemoryFail(
   #           np.mod(np.arange(np.power(128, dims)), 64).reshape(
   #               (128,) * dims).astype(np.complex64), rank)
@@ -202,7 +201,7 @@ class FFTOpsTest(BaseFFTOpsTest):
     with spectral_ops_test_util.fft_kernel_label_map():
       for np_type, tol in ((np.complex64, 1e-4), (np.complex128, 1e-8)):
         for rank in VALID_FFT_RANKS:
-          for dims in xrange(rank, rank + 3):
+          for dims in range(rank, rank + 3):
             self._compare(
                 np.mod(np.arange(np.power(4, dims)), 10).reshape(
                     (4,) * dims).astype(np_type),
@@ -219,7 +218,7 @@ class FFTOpsTest(BaseFFTOpsTest):
           return (re + im * 1j).reshape(shape)
 
         for rank in VALID_FFT_RANKS:
-          for dims in xrange(rank, rank + 3):
+          for dims in range(rank, rank + 3):
             self._compare(gen((4,) * dims).astype(np_type), rank,
                           rtol=tol, atol=tol)
 
@@ -249,7 +248,7 @@ class FFTOpsTest(BaseFFTOpsTest):
   @test_util.run_deprecated_v1
   def testError(self):
     for rank in VALID_FFT_RANKS:
-      for dims in xrange(0, rank):
+      for dims in range(0, rank):
         x = np.zeros((1,) * dims).astype(np.complex64)
         with self.assertRaisesWithPredicateMatch(
             ValueError, "Shape must be .*rank {}.*".format(rank)):
@@ -263,7 +262,7 @@ class FFTOpsTest(BaseFFTOpsTest):
     with spectral_ops_test_util.fft_kernel_label_map():
       for np_type, tol in ((np.float32, 1e-4), (np.float64, 1e-10)):
         for rank in VALID_FFT_RANKS:
-          for dims in xrange(rank, rank + 2):
+          for dims in range(rank, rank + 2):
             re = np.ones(shape=(4,) * dims, dtype=np_type) / 10.0
             im = np.zeros(shape=(4,) * dims, dtype=np_type)
             self._checkGradComplex(self._tfFFTForRank(rank), re, im,
@@ -276,7 +275,7 @@ class FFTOpsTest(BaseFFTOpsTest):
     with spectral_ops_test_util.fft_kernel_label_map():
       for np_type, tol in ((np.float32, 1e-2), (np.float64, 1e-10)):
         for rank in VALID_FFT_RANKS:
-          for dims in xrange(rank, rank + 2):
+          for dims in range(rank, rank + 2):
             re = np.random.rand(*((3,) * dims)).astype(np_type) * 2 - 1
             im = np.random.rand(*((3,) * dims)).astype(np_type) * 2 - 1
             self._checkGradComplex(self._tfFFTForRank(rank), re, im,
@@ -345,7 +344,7 @@ class RFFTOpsTest(BaseFFTOpsTest):
   def testEmpty(self):
     with spectral_ops_test_util.fft_kernel_label_map():
       for rank in VALID_FFT_RANKS:
-        for dims in xrange(rank, rank + 3):
+        for dims in range(rank, rank + 3):
           x = np.zeros((0,) * dims).astype(np.float32)
           self.assertEqual(x.shape, self._tfFFT(x, rank).shape)
           x = np.zeros((0,) * dims).astype(np.complex64)
@@ -355,7 +354,7 @@ class RFFTOpsTest(BaseFFTOpsTest):
   def testBasic(self):
     with spectral_ops_test_util.fft_kernel_label_map():
       for rank in VALID_FFT_RANKS:
-        for dims in xrange(rank, rank + 3):
+        for dims in range(rank, rank + 3):
           for size in (5, 6):
             inner_dim = size // 2 + 1
             r2c = np.mod(np.arange(np.power(size, dims)), 10).reshape(
@@ -369,7 +368,7 @@ class RFFTOpsTest(BaseFFTOpsTest):
   def testLargeBatch(self):
     if test.is_gpu_available(cuda_only=True):
       rank = 1
-      for dims in xrange(rank, rank + 3):
+      for dims in range(rank, rank + 3):
         for size in (64, 128):
           inner_dim = size // 2 + 1
           r2c = np.mod(np.arange(np.power(size, dims)), 10).reshape(
@@ -383,7 +382,7 @@ class RFFTOpsTest(BaseFFTOpsTest):
   def testBasicPlaceholder(self):
     with spectral_ops_test_util.fft_kernel_label_map():
       for rank in VALID_FFT_RANKS:
-        for dims in xrange(rank, rank + 3):
+        for dims in range(rank, rank + 3):
           for size in (5, 6):
             inner_dim = size // 2 + 1
             r2c = np.mod(np.arange(np.power(size, dims)), 10).reshape(
@@ -404,7 +403,7 @@ class RFFTOpsTest(BaseFFTOpsTest):
     if test.is_gpu_available(cuda_only=True):
       with spectral_ops_test_util.fft_kernel_label_map():
         for rank in VALID_FFT_RANKS:
-          for dims in xrange(rank, rank + 3):
+          for dims in range(rank, rank + 3):
             for size in (5, 6):
               inner_dim = size // 2 + 1
               r2c = np.mod(np.arange(np.power(size, dims)), 10).reshape(
@@ -459,7 +458,7 @@ class RFFTOpsTest(BaseFFTOpsTest):
         return ret
 
       for rank in VALID_FFT_RANKS:
-        for dims in xrange(rank, rank + 3):
+        for dims in range(rank, rank + 3):
           for size in (5, 6):
             inner_dim = size // 2 + 1
             self._compareForward(gen_real((size,) * dims), rank, (size,) * rank)
@@ -471,7 +470,7 @@ class RFFTOpsTest(BaseFFTOpsTest):
   def testError(self):
     with spectral_ops_test_util.fft_kernel_label_map():
       for rank in VALID_FFT_RANKS:
-        for dims in xrange(0, rank):
+        for dims in range(0, rank):
           x = np.zeros((1,) * dims).astype(np.complex64)
           with self.assertRaisesWithPredicateMatch(
               ValueError, "Shape .* must have rank at least {}".format(rank)):
@@ -479,7 +478,7 @@ class RFFTOpsTest(BaseFFTOpsTest):
           with self.assertRaisesWithPredicateMatch(
               ValueError, "Shape .* must have rank at least {}".format(rank)):
             self._tfIFFT(x, rank)
-        for dims in xrange(rank, rank + 2):
+        for dims in range(rank, rank + 2):
           x = np.zeros((1,) * rank)
 
           # Test non-rank-1 fft_length produces an error.
@@ -531,7 +530,7 @@ class RFFTOpsTest(BaseFFTOpsTest):
         # rfft3d/irfft3d do not have gradients yet.
         if rank == 3:
           continue
-        for dims in xrange(rank, rank + 2):
+        for dims in range(rank, rank + 2):
           for size in (5, 6):
             re = np.ones(shape=(size,) * dims, dtype=np.float32)
             im = -np.ones(shape=(size,) * dims, dtype=np.float32)
@@ -546,7 +545,7 @@ class RFFTOpsTest(BaseFFTOpsTest):
         # rfft3d/irfft3d do not have gradients yet.
         if rank == 3:
           continue
-        for dims in xrange(rank, rank + 2):
+        for dims in range(rank, rank + 2):
           for size in (5, 6):
             re = np.random.rand(*((size,) * dims)).astype(np.float32) * 2 - 1
             im = np.random.rand(*((size,) * dims)).astype(np.float32) * 2 - 1
diff --git a/tensorflow/python/kernel_tests/slice_op_test.py b/tensorflow/python/kernel_tests/slice_op_test.py
index 39d88896416..bb2995cf3cb 100644
--- a/tensorflow/python/kernel_tests/slice_op_test.py
+++ b/tensorflow/python/kernel_tests/slice_op_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import dtypes
@@ -36,7 +35,7 @@ class SliceTest(test.TestCase):
 
   def testEmpty(self):
     inp = np.random.rand(4, 4).astype("f")
-    for k in xrange(4):
+    for k in range(4):
       with self.cached_session(use_gpu=True):
         a = constant_op.constant(inp, shape=[4, 4], dtype=dtypes.float32)
         slice_t = a[2, k:k]
@@ -45,7 +44,7 @@ class SliceTest(test.TestCase):
 
   def testInt32(self):
     inp = np.random.rand(4, 4).astype("i")
-    for k in xrange(4):
+    for k in range(4):
       with self.cached_session(use_gpu=True):
         a = constant_op.constant(inp, shape=[4, 4], dtype=dtypes.int32)
         slice_t = a[2, k:k]
@@ -325,7 +324,7 @@ class SliceTest(test.TestCase):
     # the grads into the right location to compare against TensorFlow.
     np_ans = np.zeros(input_shape)
     slices = []
-    for i in xrange(len(input_shape)):
+    for i in range(len(input_shape)):
       slices.append(slice(slice_begin[i], slice_begin[i] + slice_size[i]))
     np_ans[slices] = grads
 
diff --git a/tensorflow/python/kernel_tests/summary_v1_audio_op_test.py b/tensorflow/python/kernel_tests/summary_v1_audio_op_test.py
index 1547c55f8b0..c9096a489df 100644
--- a/tensorflow/python/kernel_tests/summary_v1_audio_op_test.py
+++ b/tensorflow/python/kernel_tests/summary_v1_audio_op_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.framework import summary_pb2
 from tensorflow.python.framework import ops
@@ -44,7 +43,7 @@ class SummaryV1AudioOpTest(test.TestCase):
           tag: "snd/audio/%d"
           audio { content_type: "audio/wav" sample_rate: %d
                   num_channels: %d length_frames: %d }
-        }""" % (i, sample_rate, num_channels, length_frames) for i in xrange(3))
+        }""" % (i, sample_rate, num_channels, length_frames) for i in range(3))
     self.assertProtoEquals(expected, audio_summ)
 
   def testAudioSummary(self):
diff --git a/tensorflow/python/kernel_tests/summary_v1_image_op_test.py b/tensorflow/python/kernel_tests/summary_v1_image_op_test.py
index 56de2e933db..b1d88ad95a6 100644
--- a/tensorflow/python/kernel_tests/summary_v1_image_op_test.py
+++ b/tensorflow/python/kernel_tests/summary_v1_image_op_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.core.framework import summary_pb2
 from tensorflow.python.framework import dtypes
@@ -47,7 +46,7 @@ class SummaryV1ImageOpTest(test.TestCase):
         value {
           tag: "img/image/%d"
           image { height: %d width: %d colorspace: %d }
-        }""" % ((i,) + shape[1:]) for i in xrange(3))
+        }""" % ((i,) + shape[1:]) for i in range(3))
     self.assertProtoEquals(expected, image_summ)
 
   @test_util.run_deprecated_v1
diff --git a/tensorflow/python/kernel_tests/unstack_op_test.py b/tensorflow/python/kernel_tests/unstack_op_test.py
index 89885cf752b..12446696701 100644
--- a/tensorflow/python/kernel_tests/unstack_op_test.py
+++ b/tensorflow/python/kernel_tests/unstack_op_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.framework import constant_op
 from tensorflow.python.framework import test_util
@@ -82,7 +81,7 @@ class UnstackOpTest(test.TestCase):
     for shape in (2,), (3,), (2, 3), (3, 2), (4, 3, 2):
       data = np.random.randn(*shape)
       shapes = [shape[1:]] * shape[0]
-      for i in xrange(shape[0]):
+      for i in range(shape[0]):
         with self.cached_session():
           x = constant_op.constant(data)
           cs = array_ops.unstack(x, num=shape[0])
@@ -96,7 +95,7 @@ class UnstackOpTest(test.TestCase):
       data = np.random.randn(*shape)
       out_shape = list(shape)
       del out_shape[1]
-      for i in xrange(shape[1]):
+      for i in range(shape[1]):
         with self.cached_session():
           x = constant_op.constant(data)
           cs = array_ops.unstack(x, num=shape[1], axis=1)
diff --git a/tensorflow/python/lib/core/bfloat16.cc b/tensorflow/python/lib/core/bfloat16.cc
index fde3a837702..83097bfc605 100644
--- a/tensorflow/python/lib/core/bfloat16.cc
+++ b/tensorflow/python/lib/core/bfloat16.cc
@@ -316,48 +316,48 @@ PyTypeObject PyBfloat16_Type = {
     "bfloat16",                                // tp_name
     sizeof(PyBfloat16),                        // tp_basicsize
     0,                                         // tp_itemsize
-    nullptr,                                   // tp_dealloc
-    nullptr,                                   // tp_print
-    nullptr,                                   // tp_getattr
-    nullptr,                                   // tp_setattr
-    nullptr,                                   // tp_compare / tp_reserved
+    0,                                   // tp_dealloc
+    0,                                   // tp_print
+    0,                                   // tp_getattr
+    0,                                   // tp_setattr
+    0,                                   // tp_compare / tp_reserved
     PyBfloat16_Repr,                           // tp_repr
     &PyBfloat16_AsNumber,                      // tp_as_number
-    nullptr,                                   // tp_as_sequence
-    nullptr,                                   // tp_as_mapping
+    0,                                   // tp_as_sequence
+    0,                                   // tp_as_mapping
     PyBfloat16_Hash,                           // tp_hash
-    nullptr,                                   // tp_call
+    0,                                   // tp_call
     PyBfloat16_Str,                            // tp_str
-    nullptr,                                   // tp_getattro
-    nullptr,                                   // tp_setattro
-    nullptr,                                   // tp_as_buffer
+    0,                                   // tp_getattro
+    0,                                   // tp_setattro
+    0,                                   // tp_as_buffer
     Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,  // tp_flags
     "bfloat16 floating-point values",          // tp_doc
-    nullptr,                                   // tp_traverse
-    nullptr,                                   // tp_clear
+    0,                                   // tp_traverse
+    0,                                   // tp_clear
     PyBfloat16_RichCompare,                    // tp_richcompare
     0,                                         // tp_weaklistoffset
-    nullptr,                                   // tp_iter
-    nullptr,                                   // tp_iternext
-    nullptr,                                   // tp_methods
-    nullptr,                                   // tp_members
-    nullptr,                                   // tp_getset
-    nullptr,                                   // tp_base
-    nullptr,                                   // tp_dict
-    nullptr,                                   // tp_descr_get
-    nullptr,                                   // tp_descr_set
+    0,                                   // tp_iter
+    0,                                   // tp_iternext
+    0,                                   // tp_methods
+    0,                                   // tp_members
+    0,                                   // tp_getset
+    0,                                   // tp_base
+    0,                                   // tp_dict
+    0,                                   // tp_descr_get
+    0,                                   // tp_descr_set
     0,                                         // tp_dictoffset
-    nullptr,                                   // tp_init
-    nullptr,                                   // tp_alloc
+    0,                                   // tp_init
+    0,                                   // tp_alloc
     PyBfloat16_New,                            // tp_new
-    nullptr,                                   // tp_free
-    nullptr,                                   // tp_is_gc
-    nullptr,                                   // tp_bases
-    nullptr,                                   // tp_mro
-    nullptr,                                   // tp_cache
-    nullptr,                                   // tp_subclasses
-    nullptr,                                   // tp_weaklist
-    nullptr,                                   // tp_del
+    0,                                   // tp_free
+    0,                                   // tp_is_gc
+    0,                                   // tp_bases
+    0,                                   // tp_mro
+    0,                                   // tp_cache
+    0,                                   // tp_subclasses
+    0,                                   // tp_weaklist
+    0,                                   // tp_del
     0,                                         // tp_version_tag
 };
 
@@ -490,7 +490,7 @@ bool RegisterBfloat16Cast(int numpy_type, bool cast_is_safe) {
 }
 
 template <typename InType, typename OutType, typename Functor>
-void BinaryUFunc(char** args, npy_intp* dimensions, npy_intp* steps,
+void BinaryUFunc(char** args, npy_intp const* dimensions, npy_intp const* steps,
                  void* data) {
   const char* i0 = args[0];
   const char* i1 = args[1];
@@ -506,7 +506,7 @@ void BinaryUFunc(char** args, npy_intp* dimensions, npy_intp* steps,
 }
 
 template <typename Functor>
-void CompareUFunc(char** args, npy_intp* dimensions, npy_intp* steps,
+void CompareUFunc(char** args, npy_intp const* dimensions, npy_intp const* steps,
                   void* data) {
   BinaryUFunc<bfloat16, npy_bool, Functor>(args, dimensions, steps, data);
 }
@@ -560,7 +560,11 @@ bool Initialize() {
   NPyBfloat16_ArrFuncs.nonzero = NPyBfloat16_NonZero;
   NPyBfloat16_ArrFuncs.fill = NPyBfloat16_Fill;
 
+#if PY_MINOR_VERSION >= 9
+  Py_SET_TYPE(&NPyBfloat16_Descr, &PyArrayDescr_Type);
+#else
   Py_TYPE(&NPyBfloat16_Descr) = &PyArrayDescr_Type;
+#endif
   npy_bfloat16_ = PyArray_RegisterDataType(&NPyBfloat16_Descr);
   if (npy_bfloat16_ < 0) return false;
 
@@ -612,7 +616,7 @@ bool Initialize() {
       return false;
     }
     PyUFuncObject* ufunc = reinterpret_cast<PyUFuncObject*>(ufunc_obj.get());
-    if (types.size() != ufunc->nargs) {
+    if (types.size() != (size_t)ufunc->nargs) {
       PyErr_Format(PyExc_AssertionError,
                    "ufunc %s takes %d arguments, loop takes %lu", name,
                    ufunc->nargs, types.size());
diff --git a/tensorflow/python/lib/core/ndarray_tensor_bridge.cc b/tensorflow/python/lib/core/ndarray_tensor_bridge.cc
index 16f69341861..76f26fb0dc5 100644
--- a/tensorflow/python/lib/core/ndarray_tensor_bridge.cc
+++ b/tensorflow/python/lib/core/ndarray_tensor_bridge.cc
@@ -86,25 +86,25 @@ PyTypeObject TensorReleaserType = {
     0,                                /* tp_itemsize */
     /* methods */
     TensorReleaser_dealloc,      /* tp_dealloc */
-    nullptr,                     /* tp_print */
-    nullptr,                     /* tp_getattr */
-    nullptr,                     /* tp_setattr */
-    nullptr,                     /* tp_compare */
-    nullptr,                     /* tp_repr */
-    nullptr,                     /* tp_as_number */
-    nullptr,                     /* tp_as_sequence */
-    nullptr,                     /* tp_as_mapping */
-    nullptr,                     /* tp_hash */
-    nullptr,                     /* tp_call */
-    nullptr,                     /* tp_str */
-    nullptr,                     /* tp_getattro */
-    nullptr,                     /* tp_setattro */
-    nullptr,                     /* tp_as_buffer */
+    0,                     /* tp_print */
+    0,                     /* tp_getattr */
+    0,                     /* tp_setattr */
+    0,                     /* tp_compare */
+    0,                     /* tp_repr */
+    0,                     /* tp_as_number */
+    0,                     /* tp_as_sequence */
+    0,                     /* tp_as_mapping */
+    0,                     /* tp_hash */
+    0,                     /* tp_call */
+    0,                     /* tp_str */
+    0,                     /* tp_getattro */
+    0,                     /* tp_setattro */
+    0,                     /* tp_as_buffer */
     Py_TPFLAGS_DEFAULT,          /* tp_flags */
     "Wrapped TensorFlow Tensor", /* tp_doc */
-    nullptr,                     /* tp_traverse */
-    nullptr,                     /* tp_clear */
-    nullptr,                     /* tp_richcompare */
+    0,                     /* tp_traverse */
+    0,                     /* tp_clear */
+    0,                     /* tp_richcompare */
 };
 
 Status TF_DataType_to_PyArray_TYPE(TF_DataType tf_datatype,
diff --git a/tensorflow/python/lib/core/numpy.h b/tensorflow/python/lib/core/numpy.h
index 0098d938a08..1ecc9524703 100644
--- a/tensorflow/python/lib/core/numpy.h
+++ b/tensorflow/python/lib/core/numpy.h
@@ -32,6 +32,7 @@ limitations under the License.
 // Place `<locale>` before <Python.h> to avoid build failure in macOS.
 #include <locale>
 
+#define PY_SSIZE_T_CLEAN
 #include <Python.h>
 
 #include "numpy/arrayobject.h"
diff --git a/tensorflow/python/ops/accumulate_n_benchmark.py b/tensorflow/python/ops/accumulate_n_benchmark.py
index 08349003dc3..c67d0a1744f 100644
--- a/tensorflow/python/ops/accumulate_n_benchmark.py
+++ b/tensorflow/python/ops/accumulate_n_benchmark.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 import random
 import time
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.python.client import session
 from tensorflow.python.framework import ops
@@ -72,7 +71,7 @@ class AccumulateNBenchmark(test.Benchmark):
         validate_shape=True)
 
   def _GenerateUnorderedInputs(self, size, n):
-    inputs = [random_ops.random_uniform(shape=[size]) for _ in xrange(n)]
+    inputs = [random_ops.random_uniform(shape=[size]) for _ in range(n)]
     random.shuffle(inputs)
     return inputs
 
@@ -83,7 +82,7 @@ class AccumulateNBenchmark(test.Benchmark):
     inputs = self._GenerateUnorderedInputs(size, 1)
     queue = data_flow_ops.FIFOQueue(
         capacity=1, dtypes=[inputs[0].dtype], shapes=[inputs[0].get_shape()])
-    for _ in xrange(n - 1):
+    for _ in range(n - 1):
       op = queue.enqueue(inputs[-1])
       with ops.control_dependencies([op]):
         inputs.append(math_ops.tanh(1.0 + queue.dequeue()))
@@ -108,10 +107,10 @@ class AccumulateNBenchmark(test.Benchmark):
 
     with session.Session(graph=graph):
       for tag, op in test_ops:
-        for _ in xrange(100):
+        for _ in range(100):
           op.run()  # Run for warm up.
         start = time.time()
-        for _ in xrange(repeats):
+        for _ in range(repeats):
           op.run()
         duration = time.time() - start
         args = format_args + (tag, duration)
